// start of Vector

function Vector() {
	this.data = new Object();
	this.size = 0;
	this.add = vector_add;
	this.remove = vector_remove;
	this.indexOf = vector_indexOf;
	this.getSize = vector_getSize;
	this.clear = vector_clear;
	this.get = vector_get;
	this.put = vector_put;
	this.iterator = vector_iterator;
	this.contains = vector_contains;
	this.isEmpty = vector_isEmpty;
}
function vector_isEmpty() {
	return this.size < 1;
}
function vector_contains(anItem) {
	return this.indexOf(anItem) != -1;
}

function vector_add(anItem) {
	this.data[this.size] = anItem;
	this.size++;
}
function vector_clear() {
	this.size = 0;
	this.data = new Object();
}
function vector_remove(anItem) {
	var theIndex = this.indexOf(anItem);
	if (theIndex == -1) return;
	this.size--;
	for (var i = theIndex; i < this.size; i++)
		{
			this.data[i] = this.data[i + 1];
		}
}
function vector_indexOf(anItem) {
	for (var i = 0; i < this.size; i++)
		{
			if (this.data[i] == anItem) return i;
		}
	return -1;
}
function vector_getSize() {
	return this.size;
}
function vector_get(anIndex) {
	return this.data[anIndex];
}
function vector_put(anIndex, anObject) {
	this.data[anIndex, anObject];
}
function vector_iterator() {
	return new VectorIterator(this);
}
function VectorIterator(aVector) {
	this.vector = aVector;
	this.counter = 0;
	this.hasNext = vectorIterator_hasNext;
	this.next = vectorIterator_next;
}
function vectorIterator_hasNext() {
	return this.vector.getSize() > this.counter;
}
function vectorIterator_next() {
	if (!this.hasNext()) return null;
	var anIndex = this.counter;
	this.counter++;
	return this.vector.get(anIndex);
}


// end of Vector
// start of Set

function OrderedSet() {
	this.vector = new Vector();
	this.getSize = set_getSize;
	this.add = set_add;
	this.get = set_get;
	this.indexOf = set_indexOf;
	this.remove = set_remove;
	this.contains = set_contains;
	this.iterator = set_iterator;
	this.clear = set_clear;
	this.isEmpty = set_isEmpty;
	this.getStoreString = set_getStoreString;
}
function set_getStoreString() {
	var aString = 'anOrderedSet = new OrderedSet();\n';
	var anIterator = this.iterator();
	while (anIterator.hasNext())
		{
			aString = aString + 'anOrderedSet.add(\'' + anIterator.next() + '\');\n';
		}
	return aString;
}
function set_getSize() {
	return this.vector.getSize();
}
function set_isEmpty() {
	return this.vector.isEmpty();
}
function set_indexOf(anItem) {
	return this.vector.indexOf(anItem);
}
function set_get(anIndex) {
	return this.vector.get(anIndex);
}
function set_add(anItem) {
	if (this.vector.contains(anItem)) return;
	this.vector.add(anItem);
}
function set_remove(anItem) {
	this.vector.remove(anItem);
}
function set_contains(anItem) {
	return this.vector.contains(anItem);
}
function set_iterator(anItem) {
	return this.vector.iterator(anItem);
}
function set_clear(anItem) {
	this.vector.clear(anItem);
}

// end of Set

// start of Map

function Map() {
	this.data = new Object();
	this.keys = new OrderedSet();
	this.put = map_put;
	this.get = map_get;
	this.containsKey = map_containsKey;
	this.iterator = map_iterator;
	this.removeKey = map_removeKey;
	this.clear = map_clear;
	this.postTo = map_postTo;
	this.isEmpty = map_isEmpty;
	this.view = map_view;
}
function map_view() {
	var aMapString = '';
	var anIterator = this.iterator();
	while (anIterator.hasNext())
		{
			var aKey = anIterator.next();
			var aValue = this.get(aKey);
			aMapString = aMapString + aKey + '="' + aValue + '"\n';
		}
	alert(aMapString);
}
function map_put(aKey, aValue) {
	this.keys.add(aKey);
	this.data[aKey] = aValue;
}
function map_isEmpty() {
	return this.keys.isEmpty();
}
function map_get(aKey) {
	if (!this.containsKey(aKey)) return;
	return this.data[aKey];
}
function map_containsKey(aKey) {
	return this.keys.contains(aKey);
}
function map_iterator() {
	return this.keys.iterator();
}
function map_removeKey(aKey) {
	this.keys.remove(aKey);
	this.data[aKey] = null;
}
function map_clear() {
	this.data = new Object();
	this.keys = new OrderedSet();
}
function map_postTo(aURL) {
	var aPostString = '<form action="' + aURL + '" name="mapPoster" method="post">\n';
	var anIterator = this.iterator();
	while (anIterator.hasNext())
		{
			var aKey = anIterator.next();
			var aValue = this.get(aKey);
			aPostString = aPostString + '<input type="hidden" name="' + aKey + '" value="' + aValue + '">';
		}
	aPostString = aPostString + '</form>';
	document.getElementById('mapPoster').innerHTML=aPostString;
	document.mapPoster.submit();
}
// end of Map
