\l svg/svg.q
\l svg/pubsub.q

/ state
View.:Use.:Used.:Def.:(::)
Add:Del:()
Zap:0

/ def or use state
def:{[p;t]
 $[p in key Def;
   [Use[p]:reuse[Use p;t];Def[p;key t]:value t];
   Def[p]:t];
 }

reuse:{$[99=type x;dot undot[x],undot y;y]}
ifdef:{[p;t]if[count i:where(k:key[t])in key Def p;def[p]k[i]!t k i]}

/ animation
use:{if[count Animate;value[Animate][;0]@'key Animate];}
deanimate:{[p]![`Animate;();0b;enlist p];}
Animate:()!()
M:10

animateshrinknode:{[p]
 r:reverse til floor R;
 Animate[p]:(`shrinknode;r);
 def[dash p]dot(`visibility;`collapse);
 def[2 dash/p]dot(`visibility;`collapse);
 }

shrinknode:{[p]
 r:Animate[p;1];
 def[p]dot(`r;r 0);
 $[not count r;deanimate p;
   Animate[p;1]:1_r];
 }

animategrownode:{[p]
 r:1+til floor R;
 Animate[p]:(`grownode;r);
 }

grownode:{[p]
 r:Animate[p;1];
 def[p]dot(`r;r 0);
 $[count r;Animate[p;1]:1_r;
   [deanimate p;
    def[dash p]dot(`visibility;`visible);
    def[2 dash/p]dot(`visibility;`visible)]];
 }

animateglidenode:{[p;q]
 r:Nodes_ Nodes?q,p;
 node.m[p;r 0];
 i:ptp[r 0;r 1;floor dpp[r 0;r 1]%M];
 Animate[p]:(`glidenode;i);
 }

glidenode:{[p]
 r:Animate[p;1];
 $[not count r;deanimate p;
   [node.m[p;r 0];
    Animate[p;1]:1_r]];
 }

/ move arrowball along arrow p
arrowball:{[p]
 i:Animate[p;1];
 q:split p;
 a:Arrows_(all Arrows=q)?1b;
 m:floor dpp[a 0 1;a 2 3]%M;
 b:ptp[a 0 1;a 2 3;m]i;
 def[2 dash/p]dot((`cx;b 0);(`cy;b 1);(`visibility;`visible));
 Animate[p;1]:(i+1)mod m;
 }

animatearrow:{[p;q]Animate[fuse[p;q]]:(`arrowball;0)}

deanimatearrow:{[p;q]
 deanimate fuse[p;q];
 def[2 dash/fuse[p;q]]dot(`visibility;`collapse);
 }

/ dictionary <-> pairs
dot:{(!). undup . flip$[(2=count x)&0>type first x;enlist x;x]}
undup:{(x i;y i:value last each group x)}
undot:{flip(key x;value x)}

/ global geometry
R:20.
Rx:50.
Ry:20.
O:.3
P3:(0 0;-4 8;4 8)
W:0 0 10000 10000f

/ views
V:`

setview:{[v]
 View[v]:Def;
 Def::![Def;();0b;Atoms];
 zapatoms[];
 V::`;
 }

getview:{[v]
 if[not V=`;View[V]:Def];
 Zap::1;
 Def::View v;
 setatoms[];
 Add::Atoms;
 Add,:controls[];
 V::v;
 }

/ generate bound, control objects
controls:{bound[],raze control each Controls}
control:{[f]f[`c]. f`i`xy}

/ show/hide view
hideview:{Atoms def\:dot`visibility`collapse;}
showview:{Atoms def\:dot`visibility`visible;}

/ atoms of view
zapatoms:{
 Nodes::0#`;
 Arrows::2#enlist 0#`;
 }

setatoms:{
 Nodes::Atoms where`node=Def[Atoms;`q_type];
 Arrows::flip Def[Atoms where`arrow=Def[Atoms;`q_type];`q_from`q_to];
 }

/ atom visibility
showatom:{[p]visibility[p;`visible]}
hideatom:{[p]visibility[p;`collapse]}

visibility:{[p;a]
  partsin[p]def\:dot`visibility,a;
  e:subfrom p;f:pubto p;
  g:raze partsin each e fuse\:p;
  h:raze partsin each p fuse/:f;
  g def\:dot`visibility,a;
  h def\:dot`visibility,a;
 }

/ destroy atom (hacky)
destroy:{
 Def::![Def;();0b;x];
 Use::![Use;();0b;x];
 Used::![Used;();0b;x];
 Add::Add except x;
 x}

zapatoms[]

/ structures and views

Atoms::raze partsin each key[Def]where Def[key Def;`q_type]in`node`arrow

Nodes_::X,Y;Def[Nodes;`cx`cy]
Arrows_::X,Y;Def[(fuse'). Arrows;`x1`y1`x2`y2]

Boxes::Controls where Def[Controls;`q_type]=`opbox
Boxes_::Def[Boxes;`cx`cy]

Pushes::Controls where Def[Controls;`q_type]=`push
Pushes_::Def[Pushes;`x`y`width`height]

Toggles::Controls where Def[Controls;`q_type]=`toggle
Toggles_::Def[Toggles;`cx`cy]

Buttons::Toggles,Pushes

Bound::Def[`bound;`x1`y1`x2`y2]
World::(R+0,Bound 1),W[2 3]-R

circle:{Def[x;`cx`cy]}
line:{Def[x;`x1`y1`x2`y2]}

fuse:{`$"_"sv string each(x;y)}
split:{`$"_"vs string x}
dash:{`$string[x],"_"}

setnode:{if[not x in Nodes;Nodes,:x]}
setarrow:{if[not any all(x,y)=Arrows;Arrows[],:x,y]}

partof:{Def[x;`q_part]}
partsin:{key[Def]where x=Def[key Def;`q_part]}

statusof:{a:partsin x;a Def[a;`q_type]?`status}

arrows:{(fuse'). Arrows[;where all Arrows in x]}

pubto:{Arrows[1;where x=Arrows 0]}
subfrom:{Arrows[0;where x=Arrows 1]}

Leaves::Nodes where 0=count each Def[Nodes;`q_subnodes]
Roots::Nodes where`=Def[Nodes;`q_supernode]

subnodes:{Def[x;`q_subnodes]}
supernode:{Def[x;`q_supernode]}

/ subgraphs and connection-matrix
trans:{x|x{any x&y}/:x}/
Matrix::{x|flip x}./[(2#count Nodes)#0;flip Nodes?Arrows;:;1]
Graphs::Nodes distinct each distinct where each trans Matrix
Matrices::Matrix ./:(2#enlist@)each Nodes?Graphs

/ control line
bound:{
 def[`bound]dot(
  (`q_type;`bound);
  (`q_part;`bound);
  (`shape;`line);
  (`x1;W 0);
  (`y1;100f);
  (`x2;W 2);
  (`y2;100f);
  (`stroke;`black);
  (`stroke_width;1));
 `bound} 

/ move, execute, activate control object
movecontrol:{[f]f[`m]X,Y}
execcontrol:{[f]f[`e]X,Y}
actcontrol:{[f]f[`a]X,Y}

/ toggle button
toggle.:{[d;p;s;a]
 a*:1.;
 t:dot(
  (`q_type;`toggle);
  (`q_part;p);
  (`q_variable;d`q_variable);
  (`shape;`circle);
  (`cx;a 0);
  (`cy;a 1);
  (`r;R);
  (`fill;`black);
  (`fill_opacity;O);
  (`stroke;`black);
  (`stroke_width;1);
  (`title;p);
  (`onclick;"click(this)"));
 def[p]t;
 t:dot(
  (`q_type;`togglebutton);
  (`q_part;p);
  (`shape;`polygon);
  (`points;-12+a+/:4*(6 0;2 6;0 3;2 4));
  (`fill;`white`red value d`q_variable);
  (`stroke;`black);
  (`stroke_width;1);
  (`title;p);
  (`onclick;"click(this)"));
 def[p_:dash p]t;
 t:dot(
  (`q_type;`togglelabel);
  (`q_part;p);
  (`shape;`text);
  (`x;a[0]+R+R%5);
  (`y;a[1]+R%5);
  (`font_size;12);
  (`title;p);
  (`content;d`content));
 def[p__:dash p_]t;
 p,p_,p__}

/ togglebuttons
Controls,:`zoomtoggle`collisiontoggle`autospringtoggle`editarrowtoggle`dragarrowtoggle

/ create a togglebutton
zoomtoggle.c:toggle.[dot((`q_variable;`Z);(`content;"Zoom Out"));`zoomtoggle]
collisiontoggle.c:toggle.[dot((`q_variable;`C);(`content;"No Collisions"));`collisiontoggle]
autospringtoggle.c:toggle.[dot((`q_variable;`S);(`content;"Auto-Spring"));`autospringtoggle]
editarrowtoggle.c:toggle.[dot((`q_variable;`E);(`content;"Edit Arrows"));`editarrowtoggle]
dragarrowtoggle.c:toggle.[dot((`q_variable;`A);(`content;"Drag Arrows"));`dragarrowtoggle]

/ togglebutton initial values
zoomtoggle.i:`
autospringtoggle.i:`
collisiontoggle.i:`
editarrowtoggle.i:`
dragarrowtoggle.i:`

/ togglebutton coordinates
zoomtoggle.xy:350 40
autospringtoggle.xy:475 40
collisiontoggle.xy:600 40
editarrowtoggle.xy:725 40
dragarrowtoggle.xy:850 40

/ togglebutton execution
exectoggle:{[p;junk]
 v:Def[p;`q_variable];
 .[v;();not];
 def[dash p]dot(`fill;`white`red value v);
 }

/ togglebutton execution
zoomtoggle.e:exectoggle`zoomtoggle
collisiontoggle.e:exectoggle`collisiontoggle
autospringtoggle.e:exectoggle`autospringtoggle
editarrowtoggle.e:exectoggle`editarrowtoggle
dragarrowtoggle.e:exectoggle`dragarrowtoggle

/ pushbutton
push.:{[d;p;s;a]
 t:dot(
  (`q_type;`push);
  (`q_part;p);
  (`shape;`rect);
  (`x;a 0);
  (`y;a 1);
  (`rx;10);
  (`ry;10);
  (`width;100);
  (`height;40);
  (`onmousedown;"mousedown(this)");
  (`onmouseup;"mouseup(this)");
  (`fill;`black);
  (`fill_opacity;O);
  (`title;p);
  (`stroke;`black);
  (`stroke_width;1));
 def[p]t;
 t:dot(
  (`q_type;`status);
  (`q_part;p);
  (`shape;`text);
  (`x;d[`x]+a 0);
  (`y;d[`y]+a 1);
  (`stroke;s);
  (`onmousedown;"mousedown(this)");
  (`onmouseup;"mouseup(this)");
  (`font_size;15);
  (`title;p);
  (`content;d`content));
 def[p_:dash p]t;
 p,p_}

/ pushbuttons
Controls,:`springpush`quitpush

/ create a pushbutton
springpush.c:push.[dot((`content;"Spring All");(`x;20);(`y;25));`springpush]
quitpush.c:push.[dot((`content;"Quit Monitor");(`x;10);(`y;25));`quitpush]

/ initial pushbotton value
springpush.i:`none
quitpush.i:`none

/ pushbutton coordinates
springpush.xy:1000 20
quitpush.xy:1125 20

/ pushbutton movement
movepush:{[p;a]
 if[not b:pir[Pushes_ Pushes?p;a];D::`];
 p[`c;`none`red b;p`xy];}

springpush.m:movepush`springpush
quitpush.m:movepush`quitpush

/ pushbutton activation
actpush:{[p;junk]def[dash p]dot(`stroke;`red);}

springpush.a:actpush`springpush
quitpush.a:actpush`quitpush

/ pushbutton execution
execpush:{[p;f;junk]
 value[f][];
 def[dash p]dot(`stroke;`none);
 }

springpush.e:execpush[`springpush;`springs]
quitpush.e:execpush[`quitpush;`quitmonitor]

/ operation box
opbox.:{[d;p;s;a]
 t:dot(
  (`q_type;`opbox);
  (`q_part;p);
  (`shape;`ellipse);
  (`cx;a 0);
  (`cy;a 1);
  (`rx;Rx);
  (`ry;Ry);
  (`onmousedown;"mousedown(this)");
  (`onmouseup;"mouseup(this)");
  (`fill;`black);
  (`fill_opacity;O);
  (`title;p);
  (`stroke;`black);
  (`stroke_width;1));
 def[p]t;
 t:dot(
  (`q_type;`status);
  (`q_part;p);
  (`shape;`text);
  (`x;d[`x]+a 0);
  (`y;d[`y]+a 1);
  (`stroke;s);
  (`onmousedown;"mousedown(this)");
  (`onmouseup;"mouseup(this)");
  (`font_size;15);
  (`title;p);
  (`content;d`content));
 def[p_:dash p]t;
 p,p_}

/ opboxes
Controls,:`zoominbox`zoomoutbox

/ create an opbox
zoominbox.c:opbox.[dot((`content;"Zoom In");(`x;-25);(`y;5));`zoominbox]
zoomoutbox.c:opbox.[dot((`content;"Zoom Out");(`x;-30);(`y;5));`zoomoutbox]

/ initial opbox value
zoominbox.i:`none
zoomoutbox.i:`none

/ zoombox coordinates
zoominbox.xy:75 40
zoomoutbox.xy:210 40

/ opbox activation
actopbox:{[p;junk]def[dash p]dot(`stroke;`red);}

zoominbox.a:actopbox`zoominbox
zoomoutbox.a:actopbox`zoomoutbox

/ opbox execution
execopbox:{[p;a]
 n:Nodes(cc[Boxes_ Boxes?p;;R]each Nodes_)?1b;
 p[`c][`none;p`xy];
 if[not`=n;p[`o]n];
 }

zoominbox.e:execopbox[`zoominbox]
zoomoutbox.e:execopbox[`zoomoutbox]

/ opbox movement
moveopbox:{[p;a]p[`c;`red;sum[2 2#W]&W[0 1]|a];}

zoominbox.m:moveopbox`zoominbox
zoomoutbox.m:moveopbox`zoomoutbox

/ zoom
zoominbox.o:{[p]
 if[count q:subnodes p;
  hideatom p;
  c:flip circle each q;
  d:flip c+circle[p]-cog . c;
  q zoom'd;
  showatom each q];
 }

zoomoutbox.o:{[p]
 if[not`~s:supernode p;
  q:subnodes s;
  hideatom each q;
  zoom[s]cog . flip circle each q;
  showatom s];
 }

zoom:{[p;a]
 node.m[p;a];
 movearrows p;
 }

/ create a supernode
super:{[p;q]
 r:node.c[p]cog . flip circle each q;
 def[p]dot(`q_subnodes;q);
 q def\:dot(`q_supernode;p);
 s:raze(raze[subfrom each q]except q)arrow.c\:p;
 t:raze p arrow.c/:raze[pubto each q]except q;
 hideatom each q;
 r,s,t}

/ create a node
node.:{[d;p;a]
 setnode p;
 a*:1.;
 t:dot(
  (`q_type;`node);
  (`q_part;p);
  (`q_subnodes;d`q_subnodes);
  (`q_supernode;d`q_supernode);
  (`shape;`circle);
  (`cx;a 0);
  (`cy;a 1);
  (`r;R);
  (`fill;d`fill);
  (`fill_opacity;d`fill_opacity);
  (`stroke;`black);
  (`stroke_width;d`stroke_width);
  (`title;p);
  (`onclick;"click(this)");
  (`onmousedown;"mousedown(this)");
  (`onmouseup;"mouseup(this)"));
 def[p]t;
 t:dot(
  (`q_type;`status);
  (`q_part;p);
  (`shape;`text);
  (`x;a[0]-R%5);
  (`y;a[1]+R%5);
  (`stroke;`none);
  (`title;p);
  (`onclick;"click(this)");
  (`onmousedown;"mousedown(this)");
  (`onmouseup;"mouseup(this)");
  (`font_size;15);
  (`content;d`content));
 def[p_:dash p]t;
 t:dot(
  (`q_type;`nodelabel);
  (`q_part;p);
  (`shape;`text);
  (`x;a[0]+R+R%5);
  (`y;a[1]+R%5);
  (`font_size;12);
  (`title;p);
  (`content;string p));
 def[p__:dash p_]t;
 p,p_,p__}

node.c:node.[dot(
 (`fill`white);
 (`fill_opacity;O);
 (`stroke_width;1);
 (`q_subnodes;());
 (`q_supernode;`);
 (`content;""))]

node.m:{[p;a]
 d:select fill,fill_opacity,stroke_width,q_subnodes,q_supernode from Def p;
 d:d,select content from Def dash p;
 node.[d;p]sum[2 2#World]&World[0 1]|a;
 }

/ create an arrow
arrow.:{[d;p;q]
 setarrow[p;q];
 k:circle p;px:k 0;py:k 1;
 k:circle q;qx:k 0;qy:k 1;
 c1:pic[qx,qy;px,py;R];
 c2:pic[px,py;qx,qy;R];
 r:fuse[p;q];
 t:dot(
  (`q_type;`arrow);
  (`q_part;r);
  (`q_from;p);
  (`q_to;q);
  (`shape;`line);
  (`x1;c1 0);
  (`y1;c1 1);
  (`x2;c2 0);
  (`y2;c2 1);
  (`stroke;`black);
  (`stroke_width;d`stroke_width);
  (`title;r));
 def[r]t;
 t:dot(
  (`q_type;`arrowhead);
  (`q_part;r);
  (`shape;`polygon);
  (`points;c2+/:P3);
  (`fill;d`fill);
  (`stroke;`black);
  (`stroke_width;1);
  (`title;r);
  (`onclick;"click(this)");
  (`transform;enlist[`rotate]!enlist rot[c1;c2],c2));
 def[r_:dash r]t;
 t:dot(
  (`q_type;`arrowball);
  (`q_part;r);
  (`shape;`circle);
  (`cx;px);
  (`cy;py);
  (`r;R%5);
  (`stroke;`black);
  (`stroke_width;1);
  (`fill;`red);
  (`visibility;`collapse));
 def[r__:dash r_]t;
 r,r_,r__}

arrow.c:arrow.[dot((`stroke_width;1);(`fill;`white))]

arrow.p:{[p;q]
 a:fuse[p;q];
 d:select stroke_width from Def a;
 d:d,select fill from Def dash a;
 arrow.[d;p;q];
 }

/ hack?  rotate a triangle into position as an arrowhead
rot:{$[-90=a:angle[x;y];0f;01b~b:x>y;a+90;a+90 -90 any b]}

/ destroy an arrow
arrow.d:{[p;q]
 Arrows::Arrows@\:where not all Arrows=p,q;
 r0:fuse[p;q];
 r1:dash r0;
 destroy r0,r1}

/ point intersects with circle
pic:{[p;c;r]
 if[c[0]=p 0;:c[0],$[c[1]>p 1;c[1]-r;r+c 1]];
 if[c[1]=p 1;:$[c[0]>p 0;c[0]-r;r+c 0],c 1];
 t:r%sqrt 1+sqr m:slope[p]c;
 x1:c[0]+t;y1:c[1]+m*x1-c 0;p1:x1,y1;
 x2:c[0]-t;y2:c[1]+m*x2-c 0;p2:x2,y2;
 $[dpp[p1;p]<dpp[p2]p;p1;p2]}

/ point on line
pol:{[p;s;e]
 if[s[0]=e 0;:s[0],p 1];
 if[s[1]=e 1;:p[0],s 1];
 i:neg reciprocal k:slope[e]s;
 x:(p[1]+(k*s 0)-s[1]+i*p 0)%k-i;
 y:s[1]+k*x-s 0;
 x,y}

/ circle-line intersection?
cli:{[c;r;s;e]
 x0:c 0;y0:c 1;x1:s 0;y1:s 1;x2:e 0;y2:e 1;
 n:abs((x2-x1)*y1-y0)-(x1-x0)*y2-y1;
 $[r<n%d:sqrt((x2-x1)*x2-x1)+(y2-y1)*y2-y1;0;
   d<sqrt[((x0-x1)*x0-x1)+(y0-y1)*y0-y1]-r;0;
   d<sqrt[((x0-x2)*x0-x2)+(y0-y2)*y0-y2]-r;0;
   1b]}

/ some basic geometry & arithmetic
slope:{(%)over reverse x-y}
sqr:{x xexp 2}
rnd:{b:10 xexp x;(reciprocal b)*floor .5+b*y}
angle:{(180%2*asin 1)*atan(y[1]-x 1)%y[0]-x 0}
sign:{(neg x<0)+0<x}

/ some geometrical operations
cr:{[x;y;w;h](x+.5*(x+w)-x;y+.5*(y+h)-y)}                       	/ center of rectangle
pir:{[r;c]((c[0]>=r 0)&c[0]<=r[0]+r 2)&(c[1]>=r 1)&c[1]<=r[1]+r 3}	/ point in rectangle
cc:{[d;c;r]sqr[r*2]>sum sqr d-c}                                	/ circles overlap?
pc:{[p;c;r]sqr[r]>sum sqr p-c}                                  	/ point in circle?
dpp:{[p;q]sqrt sum sqr p-q}                                     	/ dist point to point
dpc:{[p;c;r]dpp[p;c]-r}                                         	/ dist point to circle
dpr:{[p;r]dpp[p]cr . r}                                         	/ dist point to rectangle
dpl:{[p;s;e]dpp[p]pol[p;s;e]}                                   	/ dist point to line
ipp:{[p;q;i]sums i#dpp[p;q]%i}                                  	/ increments point to point
ptp:{[p;q;i]reverse enlist[q],pic[p;q]each ipp[p;q;i]}                  / path to point p from q
cog:{(m+.5*max[x]-m:min x;m+.5*max[y]-m:min y)}                         / center of gravity

/ spring model
springs:{Graphs spring'Matrices;}

spring:{
 k:1e-009;f:.1;r:s:(y;f),flip Nodes_ Nodes?x;
 while[not all[n:ni flip r 2 3]|k>r 1;r:spr[where not n]. s:r];
 x zoom'flip s 2 3;
 }

ni:{any x{$[x~y;0;cc[x;y;R+R*.5]]}\:/:x}

spr:{[i;c;f;x;y]
 d:c[i;i];a:x i;b:y i;
 k:1-reciprocal l:d*ln[a;b];
 X:@[x;i;:;a+f*gr[d;k;a]];
 Y:@[y;i;:;b+f*gr[d;k;b]];
 $[eq[d*ln[X i;Y i]]<eq l;(c;f;X;Y);(c;f%2;x;y)]}

ln:{sqrt sqr[x-\:/:x]+sqr y-\:/:y}
gr:{sum@[y*z-\:z;::;{@[x;where not y;:;0.]};x]}
eq:{sum sum sqr x-1}
sqr:{x xexp 2}

/ xy events
X:Y:0.

xy:{
 if[all`x`y in key x;X::"F"$x`x;Y::"F"$x`y;nearest X,Y];
  $[D in Controls;movecontrol D;
    D=`background;fromnode[];
    D in Nodes;movenode D];
 }

/ highlight nearest object
nearest:{[p]
 $[any b:Pushes_ pir\:p;	highlight o:Pushes b?1b;
   any b:pc[p;;R]each Boxes_;	highlight o:Boxes b?1b;
   any b:pc[p;;R]each Toggles_; highlight o:Toggles b?1b;
   Y>Bound 3;           	highlight o:Nodes c?min c:dpc[p;;R]each Nodes_];
 lowlight each(Pushes,Boxes,Toggles,Nodes)except o;
 }

light:{[o;w;c;p]
 def[p;dot((`fill_opacity;o);(`stroke_width;w))];
 if[not`=s:statusof p;def[s;dot`stroke,c]];
 }

highlight:light[O*2;2;`white]
lowlight:light[O;1;`none]

/ mouse events
mouse:{
 e:`mouseover`mouseout`mousedown`mouseup`click`doubleclick;
 e@:where e in key x;
 (value each e)@'x e;
 }

D:`     / node down
F:`     / from node
E:1     / arrow editing

mousedown:{
 D::$[`background=x:`$x;x;partof x];
 if[D in Controls;actcontrol D];
 }

mouseup:{
 $[(not F=`)&D=`background;tonode[];
   D in Controls;execcontrol D;
   not[A]&F=`;movearrows D];
 D::`;
 }

fromnode:{if[E;if[F=`;F::Nodes e?min e:dpc[X,Y;flip Nodes_;R]]]}

tonode:{
 if[E;
  if[not F=t:Nodes e?min e:dpc[X,Y;flip Nodes_;R];
   $[E&any all Arrows=t,F;
     Del,:arrow.d[t;F];
     Add,:arrow.c[F;t]]];
  F::`;]
 }

/ collision detection
C:0
collide:{$[not C;0;any cc[X,Y;;R]each Nodes_;1;any{cli[X,Y;R;2#x;2_x]}each Arrows_]}

A:1     / drag arrows
S:0     / auto-spring

movenode:{[p]
 if[not collide[];
  node.m[p;X,Y];
  if[S;spring[Graphs i;Matrices i:(any each Graphs=p)?1b]];
  if[A;movearrows p]];
 }

movearrows:{[p]
 p arrow.p/:pubto p;
 subfrom[p]arrow.p\:p;
 }

/ single click
N:`
click:{[p]p:partof`$p;$[p in Nodes;N::p;p in Buttons;p[`e]p]}

/ double click
Z:0
doubleclick:{[p]p:partof`$p;if[p in Nodes;$[Z;zoomoutbox.o;zoominbox.o]p]}

mouseover:{[p]}
mouseout:{[p]}

/ process http message 
.http.q:{
 if[enlist[`]~key x;x:()!()];				/ empty message
 if[`err in key x;'x`err];				/ error
 if["init"~x`state;:trace .svg.end .svg.def Def];       / initial
 xy x;							/ record X,Y
 mouse x;						/ process mouse events
 use[];							/ programmer exit
 r:"";							/ accumulate updates ...
 if[Zap;r,:.svg.zap[];Zap::0];				/ zap all
 if[count Del;r,:.svg.del Del;Del::()];		        / process deleted atoms
 if[count Add;r,:.svg.def Add!Def Add;Add::()];	        / process new atoms
 if[count Use;r,:.svg.use Use];			        / process used atoms
 Used::Use;delete from`Use;Use.::(::);		        / reset	
 if[count r;r:.svg.end r];                              / end
 trace r}                                               / trace and return

/ trace (T=trace and decrement until 0)
T:0
trace:{
 if[not not T;
  if[count x;-1"\n",ssr[ssr[x;"\t";" "];"\r";"\n"]];
  T-:1];
 x}

quitmonitor:{system"\\"}

/ save/load view
saveview:{set[hsym`$x;View];}
loadview:{View::get hsym`$x;View::`;getview first key View;}

/ initial (OPT=options, -DEF file, -SCRIPT script, -WAIT 1)
OPT:.Q.opt .z.x

/ definition or script
$[`DEF in key OPT;loaddef first OPT`DEF;
  [system"l ",$[`SCRIPT in key OPT;first OPT`SCRIPT;"svg/test.q"]]]

/ browser or not
if[not`WAIT in key OPT;OPT[`WAIT]:enlist"0"]
if[not"I"$first OPT`WAIT;system"start http://",string[.z.h],":",string[system"p"],"/svg/svg.html"]

\

possible editor enhancements:

DONE 1. nearest arrow
   move: drag arrow to new node
   delete by dragging arrow to source
   
2. doubleclick on background: create new node, generate name: n0, n1, etc.
   doubleclick on node: delete

3. rename node:  drag opbox "rename", get input

DONE 4. radiobuttons:  edit, autospring, collision-detection, etc.

DONE 5. buttons: need concept of selected node (on click?)  button for spring.

6. undo?, so arrow buttons

7. make nodes button-like (e.g. activate, execute) - use views to show
   details on processes, e.g. tables, sizes, intervals, etc.

animation topics:

zoom in:  subnodes flee from cx,cy of supernode, other nodes expand outwards
zoom out: subnodes flee to cx, cy of supernode, other nodes contract inwards

animation:  

  transmitting arrow: ball moves on arrow, arrowhead moves on arrow, arrow
  grows from source to target.

  publishing:  arrows grow or move from cx, cy to perimiter
  subscribing: arrows grow or move from perimiter to cx, cy
